## ghostscript 9.22~dfsg+1

=== openjpeg/src/lib/openjp2/CMakeLists.txt ===
include_regular_expression("^.*$")

#
install( FILES  ${CMAKE_CURRENT_BINARY_DIR}/opj_config.h
 DESTINATION ${OPENJPEG_INSTALL_INCLUDE_DIR} COMPONENT Headers)

include_directories(
  ${${OPENJPEG_NAMESPACE}_BINARY_DIR}/src/lib/openjp2 # opj_config.h and opj_config_private.h
)
# Defines the source code for the library
set(OPENJPEG_SRCS
  ${CMAKE_CURRENT_SOURCE_DIR}/thread.c
  ${CMAKE_CURRENT_SOURCE_DIR}/thread.h
  ${CMAKE_CURRENT_SOURCE_DIR}/bio.c
  ${CMAKE_CURRENT_SOURCE_DIR}/bio.h
  ${CMAKE_CURRENT_SOURCE_DIR}/cio.c
  ${CMAKE_CURRENT_SOURCE_DIR}/cio.h
  ${CMAKE_CURRENT_SOURCE_DIR}/dwt.c
  ${CMAKE_CURRENT_SOURCE_DIR}/dwt.h
  ${CMAKE_CURRENT_SOURCE_DIR}/event.c
  ${CMAKE_CURRENT_SOURCE_DIR}/event.h
  ${CMAKE_CURRENT_SOURCE_DIR}/image.c
  ${CMAKE_CURRENT_SOURCE_DIR}/image.h
  ${CMAKE_CURRENT_SOURCE_DIR}/invert.c
  ${CMAKE_CURRENT_SOURCE_DIR}/invert.h
  ${CMAKE_CURRENT_SOURCE_DIR}/j2k.c
  ${CMAKE_CURRENT_SOURCE_DIR}/j2k.h
  ${CMAKE_CURRENT_SOURCE_DIR}/jp2.c
  ${CMAKE_CURRENT_SOURCE_DIR}/jp2.h
  ${CMAKE_CURRENT_SOURCE_DIR}/mct.c
  ${CMAKE_CURRENT_SOURCE_DIR}/mct.h
  ${CMAKE_CURRENT_SOURCE_DIR}/mqc.c
  ${CMAKE_CURRENT_SOURCE_DIR}/mqc.h
  ${CMAKE_CURRENT_SOURCE_DIR}/mqc_inl.h
  ${CMAKE_CURRENT_SOURCE_DIR}/openjpeg.c
  ${CMAKE_CURRENT_SOURCE_DIR}/openjpeg.h
  ${CMAKE_CURRENT_SOURCE_DIR}/opj_clock.c
  ${CMAKE_CURRENT_SOURCE_DIR}/opj_clock.h
  ${CMAKE_CURRENT_SOURCE_DIR}/pi.c
  ${CMAKE_CURRENT_SOURCE_DIR}/pi.h
  ${CMAKE_CURRENT_SOURCE_DIR}/t1.c
  ${CMAKE_CURRENT_SOURCE_DIR}/t1.h
  ${CMAKE_CURRENT_SOURCE_DIR}/t2.c
  ${CMAKE_CURRENT_SOURCE_DIR}/t2.h
  ${CMAKE_CURRENT_SOURCE_DIR}/tcd.c
  ${CMAKE_CURRENT_SOURCE_DIR}/tcd.h
  ${CMAKE_CURRENT_SOURCE_DIR}/tgt.c
  ${CMAKE_CURRENT_SOURCE_DIR}/tgt.h
  ${CMAKE_CURRENT_SOURCE_DIR}/function_list.c
  ${CMAKE_CURRENT_SOURCE_DIR}/function_list.h
  ${CMAKE_CURRENT_SOURCE_DIR}/opj_codec.h
  ${CMAKE_CURRENT_SOURCE_DIR}/opj_includes.h
  ${CMAKE_CURRENT_SOURCE_DIR}/opj_intmath.h
  ${CMAKE_CURRENT_SOURCE_DIR}/opj_malloc.c
  ${CMAKE_CURRENT_SOURCE_DIR}/opj_malloc.h
  ${CMAKE_CURRENT_SOURCE_DIR}/opj_stdint.h
)
if(BUILD_JPIP)
  add_definitions(-DUSE_JPIP)
  set(OPENJPEG_SRCS
    ${OPENJPEG_SRCS}
    ${CMAKE_CURRENT_SOURCE_DIR}/cidx_manager.c
    ${CMAKE_CURRENT_SOURCE_DIR}/cidx_manager.h
    ${CMAKE_CURRENT_SOURCE_DIR}/phix_manager.c
    ${CMAKE_CURRENT_SOURCE_DIR}/ppix_manager.c
    ${CMAKE_CURRENT_SOURCE_DIR}/thix_manager.c
    ${CMAKE_CURRENT_SOURCE_DIR}/tpix_manager.c
    ${CMAKE_CURRENT_SOURCE_DIR}/indexbox_manager.h
  )
endif()

option(OPJ_DISABLE_TPSOT_FIX "Disable TPsot==TNsot fix. See https://github.com/uclouvain/openjpeg/issues/254." OFF)
if(OPJ_DISABLE_TPSOT_FIX)
  add_definitions(-DOPJ_DISABLE_TPSOT_FIX)
endif()

# Special case for old i586-mingw32msvc-gcc cross compiler
if(NOT WIN32 AND CMAKE_COMPILER_IS_GNUCC AND CMAKE_C_COMPILER MATCHES ".*mingw32msvc.*" )
  set(WIN32 YES)
endif()

# Build the library
if(WIN32)
  if(BUILD_SHARED_LIBS)
    add_definitions(-DOPJ_EXPORTS)
  else()
    add_definitions(-DOPJ_STATIC)
  endif()
  add_library(${OPENJPEG_LIBRARY_NAME} ${OPENJPEG_SRCS})
  set(INSTALL_LIBS ${OPENJPEG_LIBRARY_NAME})
else()
  # Builds both static and dynamic libs
  add_library(${OPENJPEG_LIBRARY_NAME} SHARED ${OPENJPEG_SRCS})
  add_library(openjp2_static STATIC ${OPENJPEG_SRCS})
  set_target_properties(openjp2_static PROPERTIES OUTPUT_NAME ${OPENJPEG_LIBRARY_NAME})
  set(INSTALL_LIBS ${OPENJPEG_LIBRARY_NAME} openjp2_static)
endif()

if(UNIX)
  target_link_libraries(${OPENJPEG_LIBRARY_NAME} m)
endif()
set_target_properties(${OPENJPEG_LIBRARY_NAME} PROPERTIES ${OPENJPEG_LIBRARY_PROPERTIES})
if(${CMAKE_VERSION} VERSION_GREATER "2.8.11")
  target_compile_options(${OPENJPEG_LIBRARY_NAME} PRIVATE ${OPENJP2_COMPILE_OPTIONS})
endif()

# Install library
install(TARGETS ${INSTALL_LIBS}
  EXPORT OpenJPEGTargets
  RUNTIME DESTINATION ${OPENJPEG_INSTALL_BIN_DIR} COMPONENT Applications
  LIBRARY DESTINATION ${OPENJPEG_INSTALL_LIB_DIR} COMPONENT Libraries
  ARCHIVE DESTINATION ${OPENJPEG_INSTALL_LIB_DIR} COMPONENT Libraries
)

# Install includes files
install(FILES openjpeg.h opj_stdint.h
  DESTINATION ${OPENJPEG_INSTALL_INCLUDE_DIR} COMPONENT Headers
)

if(BUILD_DOC)
# install man page of the library
install(
  FILES       ${OPENJPEG_SOURCE_DIR}/doc/man/man3/libopenjp2.3
  DESTINATION ${OPENJPEG_INSTALL_MAN_DIR}/man3)
endif()

if(BUILD_LUTS_GENERATOR)
# internal utility to generate t1_luts.h (part of the jp2 lib)
# no need to install:
  add_executable(t1_generate_luts t1_generate_luts.c)
  if(UNIX)
    target_link_libraries(t1_generate_luts m)
  endif()
endif()

# Experimental option; let's how cppcheck performs
# Implementation details:
# I could not figure out how to easily upload a file to CDash. Instead simply
# pretend cppcheck is part of the Build step. Technically cppcheck can even
# output gcc formatted error/warning report
# Another implementation detail: I could not redirect error to the error
# catching mechanism something is busted in cmake 2.8.5, I had to use the
# warning regex to catch them.
if(OPENJPEG_CPPCHECK)
  find_package(CPPCHECK REQUIRED)
  foreach(f ${OPENJPEG_SRCS})
    # cppcheck complains about too many configuration, pretend to be WIN32:
    add_custom_command(TARGET ${OPENJPEG_LIBRARY_NAME}
      COMMAND ${CPPCHECK_EXECUTABLE} -DWIN32 ${f})
  endforeach()
endif()

if(OPJ_USE_DSYMUTIL)
  if(BUILD_SHARED_LIBS)
    add_custom_command(TARGET ${OPENJPEG_LIBRARY_NAME} POST_BUILD
    COMMAND "dsymutil" "$<TARGET_SONAME_FILE:${OPENJPEG_LIBRARY_NAME}>"
    COMMENT "dsymutil $<TARGET_SONAME_FILE:${OPENJPEG_LIBRARY_NAME}>"
    DEPENDS ${OPENJPEG_LIBRARY_NAME})
  endif()
endif()

#################################################################################
# threading configuration
#################################################################################
set(CMAKE_THREAD_PREFER_PTHREAD TRUE)

option(OPJ_USE_THREAD "Build with thread/mutex support " ON)
if(NOT OPJ_USE_THREAD)
   add_definitions( -DMUTEX_stub)
endif(NOT OPJ_USE_THREAD)

find_package(Threads QUIET)

if(OPJ_USE_THREAD AND WIN32 AND NOT Threads_FOUND )
    add_definitions( -DMUTEX_win32)
    set(Threads_FOUND YES)
endif()

if(OPJ_USE_THREAD AND Threads_FOUND AND CMAKE_USE_WIN32_THREADS_INIT )
   add_definitions( -DMUTEX_win32)
endif(OPJ_USE_THREAD AND Threads_FOUND AND CMAKE_USE_WIN32_THREADS_INIT )

if(OPJ_USE_THREAD AND Threads_FOUND AND CMAKE_USE_PTHREADS_INIT )
   add_definitions( -DMUTEX_pthread)
endif(OPJ_USE_THREAD AND Threads_FOUND AND CMAKE_USE_PTHREADS_INIT )

if(OPJ_USE_THREAD AND NOT Threads_FOUND)
  message(FATAL_ERROR "No thread library found and thread/mutex support is required by OPJ_USE_THREAD option")
endif(OPJ_USE_THREAD AND NOT Threads_FOUND)

if(OPJ_USE_THREAD AND Threads_FOUND AND CMAKE_USE_PTHREADS_INIT)
   TARGET_LINK_LIBRARIES(${OPENJPEG_LIBRARY_NAME} ${CMAKE_THREAD_LIBS_INIT})
endif(OPJ_USE_THREAD AND Threads_FOUND AND CMAKE_USE_PTHREADS_INIT)

if(BUILD_BENCH_DWT)
    add_executable(bench_dwt bench_dwt.c dwt.c opj_malloc.c thread.c)
    if(UNIX)
        target_link_libraries(bench_dwt m)
    endif()
    if(OPJ_USE_THREAD AND Threads_FOUND AND CMAKE_USE_PTHREADS_INIT)
        target_link_libraries(bench_dwt ${CMAKE_THREAD_LIBS_INIT})
    endif(OPJ_USE_THREAD AND Threads_FOUND AND CMAKE_USE_PTHREADS_INIT)
endif(BUILD_BENCH_DWT)

=== debian/changelog ===
ghostscript (9.22~dfsg+1-0ubuntu1) bionic; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    + openjpeg library bundled with upstream Ghostscript/GhostPDL used
      instead of the original openjpeg library, as the original library
      is not accepted into Ubuntu Main
      (https://bugs.launchpad.net/bugs/711061).
  * debian/libgs9.symbols: Updated for new upstream source. Applied patch
    which dpkg-gensymbols generated.

 -- Till Kamppeter <till.kamppeter@gmail.com>  Fri, 23 Feb 2018 21:12:00 +0100

ghostscript (9.22~dfsg-2) unstable; urgency=medium

  * Update Vcs-* fields for the move to salsa.d.o

 -- Didier Raboud <odyx@debian.org>  Sat, 10 Feb 2018 17:41:31 +0100

ghostscript (9.22~dfsg-1) unstable; urgency=medium

  [ upstream ]
  * New release.
    Highlights:
    + Ghostscript can now consume and produce (via the pdfwrite device)
      PDF 2.0 compliant files.
    + The main focus of this release has been security and code
      cleanliness. Hence many AddressSanitizer, Valgrind and Coverity
      issues have been addressed.
    + The usual round of bug fixes, compatibility changes, and
      incremental improvements.

  [ Jonas Smedegaard ]
  * Update copyright info:
    + Update paths of files to strip from upstream source.
    + Stop strip ConvertUTF files when repackaging upstream source: No
      longer included upstream.
  * Update watch file: Use substitution strings.
  * Update package relations:
    + Relax to build-depend unversioned on liblcms2-dev d-shlibs cdbs:
      Needed versions satisfied even in oldstable
  * Tighten lintian overrides regarding License-Reference.
  * Use https protocol for upstream Homepage.
  * Declare compliance with Debian Policy 4.1.1.
  * Drop patches applied upstream.
  * Unfuzz patches.
  * Update symbols file.

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 04 Oct 2017 17:13:06 +0200

=== debian/control ===
Source: ghostscript
Section: text
Priority: optional
Maintainer: Debian Printing Team <debian-printing@lists.debian.org>
Build-Depends: cdbs,
 autoconf,
 debhelper,
 dh-buildinfo,
 d-shlibs,
 libjpeg-dev,
 libpng-dev,
 libtrio-dev,
 libtiff-dev,
 libz-dev,
 libjbig2dec-dev,
 libijs-dev,
 libexpat-dev,
 libxt-dev,
 libxext-dev,
 libx11-dev,
 libice-dev,
 libsm-dev,
 liblcms2-dev,
 libfreetype6-dev,
 libfontconfig1-dev,
 libcups2-dev,
 libcupsimage2-dev,
 libpaper-dev,
 libidn11-dev,
 freeglut3-dev,
 pkg-config
Standards-Version: 4.1.1
Uploaders: Jonas Smedegaard <dr@jones.dk>,
 Michael Gilbert <mgilbert@debian.org>,
 Bastien ROUCARIÈS <roucaries.bastien+debian@gmail.com>
Homepage: https://www.ghostscript.com/
Vcs-Git: https://salsa.debian.org/printing-team/ghostscript.git
Vcs-Browser: https://salsa.debian.org/printing-team/ghostscript

Package: ghostscript
Architecture: any
Multi-Arch: foreign
Provides: ${cdbs:Provides}
Recommends: ${cdbs:Recommends}
Suggests: ${cdbs:Suggests}
Depends: ${shlibs:Depends},
 ${cdbs:Depends},
 libgs9 (= ${binary:Version}),
 ${misc:Depends}
Description: interpreter for the PostScript language and for PDF
 GPL Ghostscript is used for PostScript/PDF preview and printing.
 Usually as a back-end to a program such as ghostview, it can display
 PostScript and PDF documents in an X11 environment.
 .
 Furthermore, it can render PostScript and PDF files as graphics to be
 printed on non-PostScript printers. Supported printers include common
 dot-matrix, inkjet and laser models.

Package: ghostscript-x
Architecture: any
Depends: ${shlibs:Depends},
 ${cdbs:Depends},
 ${misc:Depends}
Description: interpreter for the PostScript language and for PDF - X11 support
 GPL Ghostscript is used for PostScript/PDF preview and printing.
 Usually as a back-end to a program such as ghostview, it can display
 PostScript and PDF documents in an X11 environment.
 .
 This package contains the GPL Ghostscript output device for X11.

Package: ghostscript-doc
Section: doc
Architecture: all
Depends: ${shlibs:Depends},
 ${cdbs:Depends},
 ${misc:Depends}
Suggests: ${cdbs:Suggests}
Description: interpreter for the PostScript language and for PDF - Documentation
 GPL Ghostscript is used for PostScript/PDF preview and printing.
 Usually as a back-end to a program such as ghostview, it can display
 PostScript and PDF documents in an X11 environment.
 .
 This package contains documentation for GPL Ghostscript, mainly
 targeted developers and advanced users.

Package: libgs9
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
 ${cdbs:Depends},
 ${misc:Depends},
 libgs9-common (= ${source:Version})
Multi-Arch: same
Description: interpreter for the PostScript language and for PDF - Library
 GPL Ghostscript is used for PostScript/PDF preview and printing.
 Usually as a back-end to a program such as ghostview, it can display
 PostScript and PDF documents in an X11 environment.
 .
 This package provides the Ghostscript library which makes the
 facilities of GPL Ghostscript available to applications.

Package: libgs9-common
Section: libs
Architecture: all
Depends: ${misc:Depends}
Recommends: ${cdbs:Recommends}
Multi-Arch: foreign
Description: interpreter for the PostScript language and for PDF - common files
 GPL Ghostscript is used for PostScript/PDF preview and printing.
 Usually as a back-end to a program such as ghostview, it can display
 PostScript and PDF documents in an X11 environment.
 .
 This package provides common architecture-independent files needed by
 the GPL Ghostscript library.
 .
 By default, GPL Ghostscript uses a font from the fonts-droid package to
 approximate glyphs in PDFs for which the requested CJK TrueType font
 is missing.  If the fonts-droid package is not installed, these glyphs
 will be rendered as bullets.

Package: libgs-dev
Section: libdevel
Architecture: any
Depends: ${devlibs:Depends},
 ${cdbs:Depends},
 ${misc:Depends}
Multi-Arch: same
Description: interpreter for the PostScript language and for PDF - Development Files
 GPL Ghostscript is used for PostScript/PDF preview and printing.
 Usually as a back-end to a program such as ghostview, it can display
 PostScript and PDF documents in an X11 environment.
 .
 This package provides the development files for the GPL Ghostscript
 library which makes the facilities of GPL Ghostscript available to
 applications.

Package: ghostscript-dbg
Architecture: any
Section: debug
Priority: extra
Depends: ${shlibs:Depends},
 ${cdbs:Depends},
 libgs9 (= ${binary:Version}) |
 ghostscript (= ${binary:Version}) |
 ghostscript-x (= ${binary:Version}),
 ${misc:Depends}
Description: interpreter for the PostScript language and for PDF - Debug symbols
 GPL Ghostscript is used for PostScript/PDF preview and printing.
 Usually as a back-end to a program such as ghostview, it can display
 PostScript and PDF documents in an X11 environment.
 .
 This package contains the debugging symbols for ghostscript,
 ghostscript-x, and libgs9.

=== debian/rules ===
#!/usr/bin/make -f
# -*- mode: makefile; coding: utf-8 -*-
# Copyright © 2004-2009, Masayuki Hatta (mhatta) <mhatta@debian.org>
# Copyright © 2009-2017, Jonas Smedegaard <dr@jones.dk>
# Description: Main Debian packaging script for GhostPDL
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 3, or (at
# your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

# These are needed ahead of including CDBS
# ABI by default follows upstream version (without repackaging suffix)
abi = $(firstword $(subst ~,$(space),$(DEB_UPSTREAM_VERSION)))
major = $(firstword $(subst .,$(space),$(DEB_UPSTREAM_VERSION)))
SEDRULE_CONTENT = 's/__ABI__/$(abi)/g;s/__VER__/$(major)/g'
DEB_PHONY_RULES += debian/control.in
debian/control:: debian/control.in
debian/control.in::
	sed $(SEDRULE_CONTENT) <debian/control.in.in >debian/control.in
DEB_AUTO_UPDATE_AUTOCONF = 2.67

include /usr/share/cdbs/1/class/autotools.mk
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/rules/utils.mk

libname = libgs
pkg = ghostscript
pkg-x11 = ghostscript-x
pkg-doc = ghostscript-doc
pkg-lib = $(libname)$(major)
pkg-dev = $(libname)-dev
pkg-data = $(libname)$(major)-common

# suppress checking license during build
DEB_COPYRIGHT_CHECK_LICENSECHECK =
CDBS_BUILD_DEPENDS_rules_utils_copyright-check =

# put aside upstream-shipped temp files during build but after copyright-check
DEB_UPSTREAM_CRUFT_MOVE = configure

# TODO: enable when supporting system-shared libjpeg
# http://bugs.ghostscript.com/show_bug.cgi?id=696654
DEB_CONFIGURE_EXTRA_FLAGS += --without-pcl

# workaround for autotools-resolved paths ignored in base/unix-auth.mak
export DEB_HOST_MULTIARCH

# Support parallel building if enabled in DEB_BUILD_OPTIONS
DEB_BUILD_PARALLEL = 1

gs_opts += SHARE_JPEG=1
dev-deps += jpeg

gs_opts += SHARE_LIBPNG=1
dev-deps += png

gs_opts += SHARE_TRIO=1
dev-deps += trio

gs_opts += SHARE_LIBTIFF=1
DEB_CONFIGURE_EXTRA_FLAGS += --with-system-libtiff
dev-deps += tiff

gs_opts += SHARE_ZLIB=1
dev-deps += z

gs_opts += SHARE_JBIG2=1
DEB_CONFIGURE_EXTRA_FLAGS += --with-jbig2dec
dev-deps += jbig2dec

gs_opts += SHARE_IJS=1
DEB_CONFIGURE_EXTRA_FLAGS += --with-ijs
dev-deps += ijs

gs_opts += SHARE_EXPAT=1
dev-deps += expat

DEB_CONFIGURE_EXTRA_FLAGS += --with-x --disable-gtk
dev-deps += xt xext x11 ice sm

DEB_CONFIGURE_EXTRA_FLAGS += --enable-dynamic
DEB_CONFIGURE_EXTRA_FLAGS += --disable-compile-inits

DEB_CONFIGURE_EXTRA_FLAGS += --with-drivers=ALL

gs_opts += WHICH_CMS=lcms2 SHARE_LCMS=1 LCMS2DIR=/usr
dev-deps += lcms2

# openjpeg requires patching for ICC and CMYK support
#gs_opts += SHARE_JPX=1
#DEB_CONFIGURE_EXTRA_FLAGS += --disable-openjpeg
#dev-deps += openjp2-7

# In contrary to Debian we use the openjpeg convenience library, as the Ubuntu
# security team does not accept the upstream openjpeg library into Ubuntu
# Main (https://bugs.launchpad.net/bugs/711061)
gs_opts += SHARE_JPX=0
DEB_CONFIGURE_EXTRA_FLAGS += --enable-openjpeg --without-jasper

fontdirs = /var/lib/ghostscript/fonts /usr/share/cups/fonts \
 /usr/share/ghostscript/fonts /usr/local/lib/ghostscript/fonts \
 /usr/share/fonts
gs_opts += SHARE_FT=1
DEB_CONFIGURE_EXTRA_FLAGS += --enable-freetype \
 --with-fontpath=$(subst $(space),:,$(strip $(fontdirs)))
dev-deps += freetype6 fontconfig1

# avoid building CUPS driver when bootstrapping an architecture
ifeq (,$(findstring stage1,$(DEB_BUILD_PROFILES)))
gs_opts += SHARE_LCUPS=1 SHARE_LCUPSI=1
DEB_CONFIGURE_EXTRA_FLAGS += --enable-cups
endif
dev-deps += cups2 cupsimage2

DEB_MAKE_BUILD_TARGET = so $(gs_opts)
DEB_MAKE_INSTALL_TARGET = soinstall DESTDIR=$(DEB_DESTDIR) $(gs_opts)

DEB_DH_MAKESHLIBS_ARGS_$(pkg-x11) = -n

# relax symbols check when targeting experimental
# and when bootstrapping an architecture
EXP_RELEASE = $(filter experimental% UNRELEASED,\
 $(shell dpkg-parsechangelog | grep -Po '^Distribution: \K.*'))
STAGE1 = $(findstring stage1,$(DEB_BUILD_PROFILES))
export DPKG_GENSYMBOLS_CHECK_LEVEL=$(if $(EXP_RELEASE)$(STAGE1),0,1)

DEB_COMPRESS_EXCLUDE_ALL = .pdf

pre-build:: debian/control.in.in
	echo "sed $(SEDRULE_CONTENT) <$< | diff -u debian/control.in -"
	@sed $(SEDRULE_CONTENT) <$< | diff -u debian/control.in - || ( \
		echo; \
		echo "Upstream version has changed (or debian/control.in.in is out of sync)"; \
		echo "Edit debian/control manually, or use the following command:"; \
		echo "  DEB_AUTO_UPDATE_DEBIAN_CONTROL=yes fakeroot debian/rules clean"; \
		exit 1)

# Generate (and cleanup) files containing variables static per build
infiles = $(filter-out debian/control.in debian/control.in.in, $(wildcard debian/*.in))
outfiles = $(subst $(libname)__VER__,$(pkg-lib),$(basename $(infiles)))
pre-build:: $(outfiles)
$(outfiles): update-config debian/stamp-copyright-check
	sed $(SEDRULE_CONTENT) <$(subst $(pkg-lib),$(libname)__VER__,$@).in >$@
clean::
	rm -f $(outfiles)

clean::
	[ ! -f Makefile ] || $(MAKE) soclean
	[ ! -f Makefile ] || $(MAKE) distclean
# These are somehow left...
	rm -rf sobin soobj

# Remove some of the scripts
bin-avoid = unix-lpr.sh lprsetup.sh pv.sh fixmswrd.pl
install/$(pkg)::
	rm -f $(patsubst %,$(DEB_DESTDIR)/usr/bin/%,$(bin-avoid))

# Do not include the Ghostscript loader executable with GTK support
install/$(pkg)::
	rm -f $(DEB_DESTDIR)/usr/bin/gsx

# Rename /usr/bin/gsc, to not conflict with gambc
install/$(pkg)::
	mv $(DEB_DESTDIR)/usr/bin/gsc $(DEB_DESTDIR)/usr/bin/gs
	mkdir -p $(DEB_DESTDIR)/usr/sbin/
	install -m 755 debian/update-gsfontmap $(DEB_DESTDIR)/usr/sbin

# Move ICC profiles to shared dir, to allow reuse by others.
install/$(pkg-data)::
	mkdir -p $(DEB_DESTDIR)/usr/share/color/icc
	mv $(DEB_DESTDIR)/usr/share/ghostscript/$(abi)/iccprofiles \
		$(DEB_DESTDIR)/usr/share/color/icc/ghostscript

# Strip CMap files (separately packaged in poppler-data)
install/$(pkg-data)::
	rm -rf $(DEB_DESTDIR)/usr/share/ghostscript/$(abi)/Resource/CMap

# Recommend fonts-droid (not ship DroidSansFallback.ttf)
CDBS_RECOMMENDS_$(pkg-data) +=, fonts-droid-fallback
install/$(pkg-data)::
	rm -f $(DEB_DESTDIR)/usr/share/ghostscript/$(abi)/Resource/CIDFSubst/DroidSansFallback.ttf

# Let d-shlibs calculate development package dependencies
#  and handle shared library install
CDBS_BUILD_DEPENDS +=, d-shlibs
binary-post-install/$(pkg-lib):: debian/stamp-local-shlibs-$(libname)
debian/stamp-local-shlibs-$(libname): binary-install/$(pkg-lib)
	d-shlibmove --commit \
		--devunversioned --ignorelibdep --multiarch \
		--exclude-a \
		--movedev "debian/tmp/usr/include/*" usr/include/ \
		debian/tmp/usr/lib/$(libname).so
clean::
	rm -f debian/stamp-local-shlibs-$(libname)

binary-post-install/$(pkg-data)::
	file='debian/$(cdbs_curpkg)/usr/share/ghostscript/$(abi)/Resource/Init/cidfmap'; \
	  ! egrep -v '^(%([^%].*)?)?$$' "$$file" && rm "$$file" || ( \
		echo; \
		echo 'ERROR: cidfmap not virtually empty as expected,'; \
		echo '       so some alternative to just dropping that file is required.'; \
		echo '       More info at bug#531182.'; \
		exit 1 )

# Needed at build time
dev-deps += paper idn11
CDBS_BUILD_DEPENDS +=, $(patsubst %,$(comma) lib%-dev,$(dev-deps))
CDBS_BUILD_DEPENDS +=, freeglut3-dev, pkg-config

# Needed (always, often, sometimes) at runtime
CDBS_DEPENDS_$(pkg) +=, debconf | debconf-2.0
CDBS_DEPENDS_$(pkg) +=, $(pkg-lib) (= $(DEB_VERSION))
CDBS_DEPENDS_$(pkg-x11) +=, $(pkg) (= $(DEB_VERSION))
CDBS_DEPENDS_$(pkg-lib) +=, poppler-data
CDBS_DEPENDS_$(pkg-dev) +=, $(pkg-lib) (= $(DEB_VERSION))
CDBS_RECOMMENDS_$(pkg) +=, gsfonts

## ghostscript 9.25~dfsg

=== debian/changelog ===
ghostscript (9.25~dfsg-0+deb9u1) stretch-security; urgency=high

  * Non-maintainer upload by the Security Team.
  * New upstream version 9.25~dfsg
    + Fixes regression using ps2ascii after fix for CVE-2018-17183
      (Closes: #909076)
    + status operator honour SAFER option (CVE-2018-11645)
  * Drop patches applied upstream
  * Rebase 2001_docdir_fix_for_debian.patch for 9.25
  * Rebase 2010_add_build_timestamp_setting.patch for 9.25
  * Add patches cherry-picked upstream to fix execution issues.
    + Implement .currentoutputdevice operator
    + Change "executeonly" to throw typecheck on gstatetype and
      devicetype objects
    + Undefine some additional internal operators.
    + Fix handling of .needinput if used from interpreter
    + Ensure all errors are included from initialization
    + setundercolorremoval memory corruption
    + copydevice fails after stack device copies invalidated
    + add operand checking to .setnativefontmapbuilt
    + add object type check for AES key
    + Add parameter type checking on .bigstring
    + zparse_dsc_comments can crash with invalid dsc_state
    + Catch errors in setpagesize, .setpagesize and setpagedevice and
      cleanup
    + Catch errors and cleanup stack on statusdict page size definitions
    + Add parameter checking in setresolution
    + device subclass open_device call must return child code
    + fix DSC comment parsing in pdfwrite
    + Check all uses of dict_find* to ensure 0 return properly handled
    + permit Mod and CreDate pdfmarks in PDF 2.0 in pdfwrite
    + Avoid overrunning non terminated string buffer.
    + Prevent SEGV in gs_setdevice_no_erase.
    + Fix uninitialised value for render_cond.
    + Hide the .needinput operator
    + filenameforall calls bad iodev with insufficent scratch
    + Improve hiding of security critical custom operators (CVE-2018-17961)
      (Closes: #911175)
    + Prevent SEGV after calling gs_image_class_1_simple.
    + don't push userdict in preparation for Type 1 fonts
    + add control over hiding error handlers. (Closes: #909929)
    + For hidden operators, pass a name object to error handler.
      (CVE-2018-17961) (Closes: #911175)
    + Explicitly exclude /unknownerror from the SAFERERRORLIST
    + don't include operator arrays in execstack output (CVE-2018-18073)
      (Closes: #910758)
    + Make .forceput unavailable from '.policyprocs' helper dictionary
      (CVE-2018-18284) (Closes: #911175)
    + .loadfontloop must be an operator (CVE-2018-17961) (Closes: #911175)
    + font parsing - prevent SEGV in .cffparse
  * openjpeg allocator must return NULL if size too large
  * debian/copyright: Refresh with version from 9.25~dfsg-5
  * debian/libgs9.symbols: Update (and sync from 9.25~dfsg-5) for new version.
    Adjust version for errorexec_find@Base.
  * Fix cups get/put_params LeadingEdge logic (cf. #912664)
  * Avoid privacy breach linking documentation to jquery:
    + Add patch 2009 to use local jquery.
    + Add symlink from relative link to system-shared jquery library.
    + Have ghostscript-doc depend on libjs-jquery.
  * Avoid privacy breach linking documentation to font:
    + Avoid linking to remote fonts in documentation.
  * Avoid privacy breach linking documentation with Google:
    + Strip googletagmanager code from documentation.

 -- Salvatore Bonaccorso <carnil@debian.org>  Thu, 08 Nov 2018 16:06:47 +0100

ghostscript (9.20~dfsg-3.2+deb9u5) stretch-security; urgency=medium

  * Fixes for CVE-2018-16509 (fourth patch, rest were applied in deb9u4)
    CVE-2018-16802 and one additional issue with a CVE ID (yet)

 -- Moritz Mühlenhoff <jmm@debian.org>  Fri, 14 Sep 2018 22:53:46 +0200

ghostscript (9.20~dfsg-3.2+deb9u4) stretch-security; urgency=medium

  * Add additional patch for CVE-2018-16543
  * Fix a regression introduced in a054156d425b4dbdaaa9fda4b5f1182b27598c2b,
    see https://github.com/apple/cups/issues/5392

 -- Moritz Mühlenhoff <jmm@debian.org>  Thu, 06 Sep 2018 00:02:35 +0200

ghostscript (9.20~dfsg-3.2+deb9u3) stretch-security; urgency=medium

  * Multiple security issues, see Security Tracker for details

 -- Moritz Mühlenhoff <jmm@debian.org>  Wed, 29 Aug 2018 21:17:15 +0200

ghostscript (9.20~dfsg-3.2+deb9u2) stretch; urgency=medium

  * Non-maintainer upload.
  * Segfault with fuzzing file in gxht_thresh_image_init
  * Buffer overflow in fill_threshold_buffer (CVE-2016-10317)
    (Closes: #860869)
  * pdfwrite - Guard against trying to output an infinite number
    (CVE-2018-10194) (Closes: #896069)

 -- Salvatore Bonaccorso <carnil@debian.org>  Sun, 29 Apr 2018 10:58:15 +0200

=== debian/rules ===
--- 
+++ 
@@ -40,9 +40,15 @@
 pkg-dev = $(libname)-dev
 pkg-data = $(libname)$(major)-common
 
-# suppress checking license during build
-DEB_COPYRIGHT_CHECK_LICENSECHECK =
-CDBS_BUILD_DEPENDS_rules_utils_copyright-check =
+# extract metadata from ICC, PDF, and fonts before copyright check
+# - skip main HTML documentation and a spreadsheet
+# - skip binary non-metadata-parseable graphics formats (ico pcl xps)
+# - skip binary non-metadata-parseable certificate bundle (cat)
+DEB_COPYRIGHT_EXTRACT_EXTS = icc pdf ttf
+DEB_COPYRIGHT_EXTRACT_PATHS_EXIF = Resource/Font/
+DEB_COPYRIGHT_CHECK_IGNORE_EXTS = cat ico xls pcl xps
+DEB_COPYRIGHT_CHECK_IGNORE_PATHS = doc/.*\.htm
+#DEB_COPYRIGHT_CHECK_MERGE_SAME_LICENSE = yes
 
 # put aside upstream-shipped temp files during build but after copyright-check
 DEB_UPSTREAM_CRUFT_MOVE = configure
@@ -90,21 +96,18 @@
 DEB_CONFIGURE_EXTRA_FLAGS += --enable-dynamic
 DEB_CONFIGURE_EXTRA_FLAGS += --disable-compile-inits
 
+# TODO: enable when working again (failed since 9.07 and maybe 9.06)
+#DEB_CONFIGURE_EXTRA_FLAGS += --with-omni
 DEB_CONFIGURE_EXTRA_FLAGS += --with-drivers=ALL
 
+# need recent lcms supporting threads (via cmsPluginTHR() call)
 gs_opts += WHICH_CMS=lcms2 SHARE_LCMS=1 LCMS2DIR=/usr
-dev-deps += lcms2
+CDBS_BUILD_DEPENDS +=, liblcms2-dev (>= 2.5)
 
 # openjpeg requires patching for ICC and CMYK support
-#gs_opts += SHARE_JPX=1
+gs_opts += SHARE_JPX=1
 #DEB_CONFIGURE_EXTRA_FLAGS += --disable-openjpeg
-#dev-deps += openjp2-7
-
-# In contrary to Debian we use the openjpeg convenience library, as the Ubuntu
-# security team does not accept the upstream openjpeg library into Ubuntu
-# Main (https://bugs.launchpad.net/bugs/711061)
-gs_opts += SHARE_JPX=0
-DEB_CONFIGURE_EXTRA_FLAGS += --enable-openjpeg --without-jasper
+dev-deps += openjp2-7
 
 fontdirs = /var/lib/ghostscript/fonts /usr/share/cups/fonts \
  /usr/share/ghostscript/fonts /usr/local/lib/ghostscript/fonts \
@@ -126,14 +129,10 @@
 
 DEB_DH_MAKESHLIBS_ARGS_$(pkg-x11) = -n
 
-# relax symbols check when targeting experimental
-# and when bootstrapping an architecture
-EXP_RELEASE = $(filter experimental% UNRELEASED,\
- $(shell dpkg-parsechangelog | grep -Po '^Distribution: \K.*'))
-STAGE1 = $(findstring stage1,$(DEB_BUILD_PROFILES))
-export DPKG_GENSYMBOLS_CHECK_LEVEL=$(if $(EXP_RELEASE)$(STAGE1),0,1)
-
-DEB_COMPRESS_EXCLUDE_ALL = .pdf
+# avoid checking symbols file when bootstrapping an architecture
+ifneq (,$(findstring stage1,$(DEB_BUILD_PROFILES)))
+DEB_DH_MAKESHLIBS_ARGS = -- -c0
+endif
 
 pre-build:: debian/control.in.in
 	echo "sed $(SEDRULE_CONTENT) <$< | diff -u debian/control.in -"
@@ -191,7 +190,8 @@
 
 # Let d-shlibs calculate development package dependencies
 #  and handle shared library install
-CDBS_BUILD_DEPENDS +=, d-shlibs
+# * recent d-shlibs needed to handle libtrio quirk
+CDBS_BUILD_DEPENDS +=, d-shlibs (>= 0.58~)
 binary-post-install/$(pkg-lib):: debian/stamp-local-shlibs-$(libname)
 debian/stamp-local-shlibs-$(libname): binary-install/$(pkg-lib)
 	d-shlibmove --commit \
@@ -220,6 +220,3 @@
 CDBS_DEPENDS_$(pkg) +=, debconf | debconf-2.0
 CDBS_DEPENDS_$(pkg) +=, $(pkg-lib) (= $(DEB_VERSION))
 CDBS_DEPENDS_$(pkg-x11) +=, $(pkg) (= $(DEB_VERSION))
-CDBS_DEPENDS_$(pkg-lib) +=, poppler-data
-CDBS_DEPENDS_$(pkg-dev) +=, $(pkg-lib) (= $(DEB_VERSION))
-CDBS_RECOMMENDS_$(pkg) +=, gsfonts

## ghostscript 9.25~dfsg+1

=== debian/changelog ===
ghostscript (9.25~dfsg+1-0ubuntu1) cosmic; urgency=medium

  * New upstream bug fix release
    Highlights:
    - Highly recommended by upstream, release done to fix regressions in 9.24.
    - This release fixes problems with argument handling, some unintended
      results of the security fixes to the SAFER file access restrictions
      (specifically accessing ICC profile files), and some additional security
      issues over the recent 9.24 release.
    - Note: The ps2epsi utility does not, and cannot call Ghostscript with
      the -dSAFER command line option. It should never be called with input
      from untrusted sources.
  * Removed patch 020180906-bc3df07-*.patch backported from upstream.
  * Refreshed patches 2003_support_multiarch.patch and
    2007_suggest_install_ghostscript-doc_in_code.patch with quilt.
  * debian/libgs9.symbols: Updated for new upstream source. Applied patch
    which dpkg-gensymbols generated.

 -- Till Kamppeter <till.kamppeter@gmail.com>  Thu, 13 Sep 2018 20:27:06 +0200

ghostscript (9.24~dfsg+1-0ubuntu1) cosmic; urgency=medium

  * New upstream release (LP: #1791279)
    Highlights:
    - Security issues have been the primary focus of this release,
      including solving several (well publicised) real and potential
      exploits.
      Upstream highly recommends this due to the many security fixes
      and improvements.
  * debian/copyright, debian/rules: Upstream renamed the lcms2art/ directory
    to lcms2mt/.
  * Removed patch CVE-2018-10194.patch backported from upstream.
  * Refreshed patch 2010_add_build_timestamp_setting.patch with quilt.
  * 020180906-bc3df07-for-icc-profile-validation-have-cups-id-itself-as-device-n.patch:
    "cups" output device did not work because there were no output profiles
    for all color spaces (Upstream bug #699713).
  * Merged from Debian package:
    - Update copyright-check maintainer script: Extract metadata from png files.
    - Update copyright info:
      + Extend coverage for main upstream author.
      + Extend coverage for Adobe.
    - Extend lintian overrides regarding License-Reference.
    - Declare compliance with Debian Policy 4.2.0.
  * debian/libgs9.symbols: Updated for new upstream source. Applied patch
    which dpkg-gensymbols generated.

 -- Till Kamppeter <till.kamppeter@gmail.com>  Thu, 06 Sep 2018 20:21:03 +0200

ghostscript (9.23~dfsg+1-0ubuntu2) cosmic; urgency=medium

  * Build with -O2 on ppc64el to avoid FTBFS

 -- Graham Inggs <ginggs@ubuntu.com>  Sat, 11 Aug 2018 11:41:40 +0000

ghostscript (9.23~dfsg+1-0ubuntu1) cosmic; urgency=medium

  * New upstream release
    Highlights:
    + Ghostscript now has a family of 'pdfimage' devices (pdfimage8,
      pdfimage24 and pdfimage32) which produce rendered output wrapped
      up as an image in a PDF. Additionally, there is a 'pclm' device
      which produces PCLm format output.
    + There is now a ColorAccuracy parameter allowing the user to
      decide between speed or accuracy in ICC color transforms.
    + JPEG Passthrough: devices which support it can now receive the
      'raw' JPEG stream from the interpreter. The main use of this is
      the pdfwrite/ps2write family of devices that can now take JPEG
      streams from the input file(s) and write them unchanged to the
      output (thus avoiding additional quantization effects).
    + PDF transparency performance improvements
  * Difference to Debian package:
    + openjpeg library bundled with upstream Ghostscript/GhostPDL used
      instead of the original openjpeg library, as the original library
      is not accepted into Ubuntu Main
      (https://bugs.launchpad.net/bugs/711061).
  * Use bundled lcms2art instead of system's liblcms2 as the former
    one is made thread safe and also contains preformance enhancements
    which got rejected upstream.
  * Updated list of stripped files/paths in debian/copyright
  * Added licenses of bundled openjpeg and lcms2 libraries to
    debian/copyright
  * Updated/refreshed the 20* patches
  * Dropped CVE-2016-10317.patch as it is included upstream.
  * debian/libgs9.symbols: Updated for new upstream source. Applied patch
    which dpkg-gensymbols generated.

 -- Till Kamppeter <till.kamppeter@gmail.com>  Wed, 08 Aug 2018 13:29:37 +0200

ghostscript (9.22~dfsg+1-0ubuntu1.1) bionic-security; urgency=medium

  * SECURITY UPDATE: Heap-based buffer overflow and application crash
    - debian/patches/CVE-2016-10317.patch: check max_height bounds in
      base/gxht_thresh.c, base/gxipixel.c.
    - CVE-2016-10317
  * SECURITY UPDATE: Denial of service
    - debian/patches/CVE-2018-10194.patch: avoid infinite number
      in devices/vector/gdevpdts.c.
    - CVE-2018-10194

 -- Leonidas S. Barbosa <leo.barbosa@canonical.com>  Tue, 24 Apr 2018 14:34:45 -0300

## ghostscript 9.26~dfsg

=== debian/changelog ===
ghostscript (9.26~dfsg-0+deb9u2) stretch-security; urgency=high

  * Non-maintainer upload by the Security Team.
  * Add patches cherry-picked upstream to fix segfault with certain PDFs with
    -dLastPage=1. (Closes: #915832)

 -- Salvatore Bonaccorso <carnil@debian.org>  Sun, 23 Dec 2018 11:15:43 +0100

ghostscript (9.26~dfsg-0+deb9u1) stretch-security; urgency=high

  * Non-maintainer upload by the Security Team.
  * New upstream version 9.26~dfsg
    + Includes fixes for the following security vulnerabilities:
      CVE-2018-19409 CVE-2018-19475 CVE-2018-19476 CVE-2018-19477
  * Drop patches cherry-picked upstream now applied
  * Unfuzz patch 2009.
  * Update symbols: 12 private added.

 -- Salvatore Bonaccorso <carnil@debian.org>  Sat, 24 Nov 2018 23:32:54 +0100
